import threading
import time
import copy
import memtestdata

class MemtestThread(threading.Thread):

    def __init__(self, tnum, count):
        self.tnum = tnum
        self.count = count
        threading.Thread.__init__(self, None, None, 'MemtestThread')

    def run(self):
        resources = copy.deepcopy(memtestdata.data)
        c=False
        for x in xrange(self.count):
            strarray = ['<params><param>']
            for r in resources:
                strarray.append('<value><array><data>')
                for a in r:
                    strarray.append('<value><string>')
                    strarray.append(str(a))
                    strarray.append('</string></value>\n')
                strarray.append('</data></array></value>\n')
            strarray.append('</param></params>/n')
            s = ''.join(strarray)
            print "thread(%d) string is %d bytes" % (self.tnum,len(s))
            if c:
                i.reverse()
                for i in resources:
                    i[0] = i[0].upper()
                c = False
            else:
                for i in resources:
                    i[0] = i[0].lower()
                i.reverse()
                c = True

        return True


for i in xrange(500):
    xts = []
    for tn in range(20):
        xt = MemtestThread(tn, 20)
        xts.append(xt)
        xt.start()

    for xt in xts:
        xt.join()

    print '===== quiet time =====', i
    time.sleep(30)


